/*! A contribution to the open-source movement.
 *  Jean-Luc Cooke <jlcooke@certainkey.com>
 *     CertainKey Inc.
 *     Ottawa Ontario Canada
 *
 *  Created: July 20th, 2001
 *
 *  The following program code is released under the GPL license
 *    http://www.gnu.org/copyleft/gpl.html
 */

#include "hashcom.h"

#define ckstring_case_tab(ii)\
  ckstring_case_tab_[(ii) & 0xff]
const char ckstring_case_tab_[256] = {
((char)0x00), ((char)0x01), ((char)0x02), ((char)0x03), ((char)0x04), ((char)0x05), ((char)0x06), ((char)0x07),
((char)0x08), ((char)0x09), ((char)0x0a), ((char)0x0b), ((char)0x0c), ((char)0x0d), ((char)0x0e), ((char)0x0f),
((char)0x10), ((char)0x11), ((char)0x12), ((char)0x13), ((char)0x14), ((char)0x15), ((char)0x16), ((char)0x17),
((char)0x18), ((char)0x19), ((char)0x1a), ((char)0x1b), ((char)0x1c), ((char)0x1d), ((char)0x1e), ((char)0x1f),
((char)0x20), ((char)0x21), ((char)0x22), ((char)0x23), ((char)0x24), ((char)0x25), ((char)0x26), ((char)0x27),
((char)0x28), ((char)0x29), ((char)0x2a), ((char)0x2b), ((char)0x2c), ((char)0x2d), ((char)0x2e), ((char)0x2f),
((char)0x30), ((char)0x31), ((char)0x32), ((char)0x33), ((char)0x34), ((char)0x35), ((char)0x36), ((char)0x37),
((char)0x38), ((char)0x39), ((char)0x3a), ((char)0x3b), ((char)0x3c), ((char)0x3d), ((char)0x3e), ((char)0x3f),
((char)0x40), ((char)0x61), ((char)0x62), ((char)0x63), ((char)0x64), ((char)0x65), ((char)0x66), ((char)0x67),
((char)0x68), ((char)0x69), ((char)0x6a), ((char)0x6b), ((char)0x6c), ((char)0x6d), ((char)0x6e), ((char)0x6f),
((char)0x70), ((char)0x71), ((char)0x72), ((char)0x73), ((char)0x74), ((char)0x75), ((char)0x76), ((char)0x77),
((char)0x78), ((char)0x79), ((char)0x7a), ((char)0x5b), ((char)0x5c), ((char)0x5d), ((char)0x5e), ((char)0x5f),
((char)0x60), ((char)0x61), ((char)0x62), ((char)0x63), ((char)0x64), ((char)0x65), ((char)0x66), ((char)0x67),
((char)0x68), ((char)0x69), ((char)0x6a), ((char)0x6b), ((char)0x6c), ((char)0x6d), ((char)0x6e), ((char)0x6f),
((char)0x70), ((char)0x71), ((char)0x72), ((char)0x73), ((char)0x74), ((char)0x75), ((char)0x76), ((char)0x77),
((char)0x78), ((char)0x79), ((char)0x7a), ((char)0x7b), ((char)0x7c), ((char)0x7d), ((char)0x7e), ((char)0x7f),
((char)0x80), ((char)0x81), ((char)0x82), ((char)0x83), ((char)0x84), ((char)0x85), ((char)0x86), ((char)0x87),
((char)0x88), ((char)0x89), ((char)0x8a), ((char)0x8b), ((char)0x8c), ((char)0x8d), ((char)0x8e), ((char)0x8f),
((char)0x90), ((char)0x91), ((char)0x92), ((char)0x93), ((char)0x94), ((char)0x95), ((char)0x96), ((char)0x97),
((char)0x98), ((char)0x99), ((char)0x9a), ((char)0x9b), ((char)0x9c), ((char)0x9d), ((char)0x9e), ((char)0x9f),
((char)0xa0), ((char)0xa1), ((char)0xa2), ((char)0xa3), ((char)0xa4), ((char)0xa5), ((char)0xa6), ((char)0xa7),
((char)0xa8), ((char)0xa9), ((char)0xaa), ((char)0xab), ((char)0xac), ((char)0xad), ((char)0xae), ((char)0xaf),
((char)0xb0), ((char)0xb1), ((char)0xb2), ((char)0xb3), ((char)0xb4), ((char)0xb5), ((char)0xb6), ((char)0xb7),
((char)0xb8), ((char)0xb9), ((char)0xba), ((char)0xbb), ((char)0xbc), ((char)0xbd), ((char)0xbe), ((char)0xbf),
((char)0xc0), ((char)0xc1), ((char)0xc2), ((char)0xc3), ((char)0xc4), ((char)0xc5), ((char)0xc6), ((char)0xc7),
((char)0xc8), ((char)0xc9), ((char)0xca), ((char)0xcb), ((char)0xcc), ((char)0xcd), ((char)0xce), ((char)0xcf),
((char)0xd0), ((char)0xd1), ((char)0xd2), ((char)0xd3), ((char)0xd4), ((char)0xd5), ((char)0xd6), ((char)0xd7),
((char)0xd8), ((char)0xd9), ((char)0xda), ((char)0xdb), ((char)0xdc), ((char)0xdd), ((char)0xde), ((char)0xdf),
((char)0xe0), ((char)0xe1), ((char)0xe2), ((char)0xe3), ((char)0xe4), ((char)0xe5), ((char)0xe6), ((char)0xe7),
((char)0xe8), ((char)0xe9), ((char)0xea), ((char)0xeb), ((char)0xec), ((char)0xed), ((char)0xee), ((char)0xef),
((char)0xf0), ((char)0xf1), ((char)0xf2), ((char)0xf3), ((char)0xf4), ((char)0xf5), ((char)0xf6), ((char)0xf7),
((char)0xf8), ((char)0xf9), ((char)0xfa), ((char)0xfb), ((char)0xfc), ((char)0xfd), ((char)0xfe), ((char)0xff)
};

#define strncasecmp(AA,BB,LL)\
  ckstrncasecmp(AA, BB, LL)
int ckstrncasecmp(const char *a, const char *b, int k) {
  while (*b != '\0'  &&  *a != '\0'  &&  0 < k--) { 
    if (ckstring_case_tab(*a) < ckstring_case_tab(*b)) return -1;
    if (ckstring_case_tab(*a) > ckstring_case_tab(*b)) return 1;
    a++;
    b++;
  }
  if (k != 0) {
    if (*a != '\0') return 1;
    if (*b != '\0') return -1;
  }
  return 0;
}

const char hashcom_PADDING[128] = {
  (char)0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,          0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,          0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,          0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,          0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,          0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,          0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,          0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
};

const void* crypto_hash_name_arr[CRYPTO_HASH_COUNT][2] = {
{(void*)CRYPTO_HASH_NONE, "None"},
{(void*)CRYPTO_HASH_MD5, "MD5"},
{(void*)CRYPTO_HASH_SHA1, "SHA-1"},
{(void*)CRYPTO_HASH_RIPEMD160, "RIPEMD-160"},
{(void*)CRYPTO_HASH_SHA512, "SHA-512"},
{(void*)CRYPTO_HASH_SHA384, "SHA-384"},
{(void*)CRYPTO_HASH_SHA256, "SHA-256"},
};

const char* crypto_name(const void* tab[][2], int count, int v) {
  int i;
  for (i=0; i<count; i++)
    if ( (int)tab[i][0] == v )
      return (char*)(tab[i][1]);
  return "Unknown";
}

unsigned int crypto_name_rev(const void* tab[][2], int count, const char *str) {
  int i;
  for (i=0; i<count; i++) {
    str = &str[strspn(str," \t\n\r")];
    if ( strncasecmp((char*)tab[i][1], str, strlen((char*)tab[i][1])) == 0
        &&  strlen(str) == strlen((char*)tab[i][1]))
      return (int)tab[i][0];
  }
  return 0;
}
